<?php
/**
 * @file
 * @brief Validator checks all published messages, sends reminders and erases invalid messages.
 *
 * This is included in the cron.php.
 */
require_once (dirname(__FILE__) . '/config.php');
require_once (dirname(__FILE__) . '/i18n.php');

// cleanup staging
$dir = opendir(dirname(__FILE__) . "/data/staging/");
while(($file = readdir($dir)) !== false) {
 if ($file !== '.' && $file !== '..' && filemtime(dirname(__FILE__) . "/data/staging/".$file) < strtotime("-1 month")) {
  unlink(dirname(__FILE__) . "/data/staging/".$file);
 }
}
closedir($dir);

$files = array();
$dir = opendir(dirname(__FILE__) . "/data/");
while(($file = readdir($dir)) !== false) {
 if ($file !== '.' && $file !== '..' && endsWith($file, '.ok')) {
  $files[] = $file;
 }
}
closedir($dir);
rsort($files);

foreach($files as $file) {
 $o = json_decode(file_get_contents(dirname(__FILE__) . "/data/" . $file));
 if ($o->reminder < time()) {
  // send reminder with prolong link
  
  $o->reminder = $o->valid_to + 3600 * 24 * 3; // fictive reminder 3 days after erasure
  
  $lang=$o->lang;
  $title = i18n('Beitrag Verlängern:').' "' . $o->title . '"';
  $mail = str_replace(array("%name%", "%valid_to%"), array($o->name, date('Y-m-d', $o->valid_to)), i18n("Hallo %name%,\n\nnach dem %valid_to% endet die Gültigkeit des Beitrags auf der Pinnwand, sofern nicht durch aufrufen dieses Links im Browser die Gültigkeit des Beitrags verlängert wird:")) . "\n\n" . HTTP_BASE . 'prolong.php?stamp=' . base_convert($o->id, 10, 36) . '&hash=' . base_convert($o->reminder, 10, 36) . "\n\n";
  $mail .= i18n('Zum sofortigen Löschen des Beitrags öffnen Sie bitte folgende Seite:') . " \n" . HTTP_BASE . 'delete.php?stamp=' . base_convert($o->id, 10, 36) . "\nn";
  $mail .= i18n('Mit freundlichen Grüssen,') . "\n'.NAME_PROVIDER.'\n\n";
  
  mail($o->email, $title, $mail, "From: " . EMAIL_PROVIDER . "\r\nContent-Type: text/plain; charset=utf-8\r\nContent-Transfer-Encoding: 8bit\r\n");
  
  file_put_contents(dirname(__FILE__) . '/data/' . $file, json_encode($o));
  busy('emailed ' . $o->name . ' ' . $o->email . ' prolong for ' . $o->title);
 } else if ($o->valid_to < time()) {
  // erase invalid messages
  unlink(dirname(__FILE__) . "/data/" . $file);
  busy('invalidated ' . $file);
 }
}
?>
